<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width= , initial-scale=1.0">
    <title>CSS Bootstrap Flex</title>

    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css"
        integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">

    <!-- Custom CSS -->
    <!-- <link rel="stylesheet" href="./index.css"> -->

</head>

<body>
    <div class="text-center">

        <h1>Bootstrap Flex</h1>
        <p>Use the d-flex class to create a flex container and transform direct into flex items</p>
        <h2>Centering Elements</h2>

        <!-- 
				Note: 
					- The "flex" value of the "display" property will change the element into a block-level flex container.
					- This will make all the child elements become "flexible" that allows them to occupy space enough for the content of an element and at the same time will have the elements appear beside each other.
					- The "d-flex" class will change all the child div elements into flex items.
					- The flex items will only occupy space enough for the element's content allowing is
                    - The flex items will only occupy space enough for the element's content allowing is more flexibility to manipulate our elements. -->

        <!-- "justiify-content"
			 		- The CSS "justify-content" property allows us to manipulate the positioning of elements horizontally.
					- The CSS "justify-content" property may only be applied if the element has a "flex" value for it's "display" property.
					- The "justify-content-center" class will horizontally center all child elements.
					- There may be instances that justify-content property may not work due to a lack of width on it's parent element.
			  -->

        <!-- "align-items" 
					- The CSS "align-items" property allows us to manipulate the positioning of elements vertically.
					- The CSS "align-items" property may only be applied if the element has a "flex" value for it's "display" property.
					- The "align-items-center" class will vertically center all child elements.
					- There may be instances that align-items property may not work due to a lack of height on it's parent element.
					- Using the combination of the CSS "height" property and the align-items property helps align elements vertically.
              -->

        <!-- "flex-direction"
					- The CSS "flex-direction" property allows us to manipulate the direction of how elements are positioned inside a flex container.
					- The "column-reverse" value will display the elements vertically.
					- The CSS "flex-direction" property may only be applied if the element has a "flex" value for it's "display" property.
					- The "flex-column" class will display elements on top of each other.
                    - A practical application of this might be to create a side navbar or centered items that should stack on top of each other.
					- Using the combination of the CSS "height" property and the align-items property helps align elements vertically.
			    -->

        <div style="Height: 500px"
            class="bg-secondary p-3 d-flex justify-content-center align-items-center flex-column">
            <div class="h-25 p-3 bg-success">Flex Item A</div>
            <div class="h-25 p-3 bg-warning">Flex Item B</div>
            <div class="h-25 p-3 bg-danger">Flex Item C</div>
        </div>

        <!-- Note:
				- The "flex-row" and "flex-row-reverse" classes may only be applied if the element has a "flex" value for it's "display" property.
				- The CSS "flex-row" and "flex-row-reverse" classes changes how the elements are displayed horizontally.
			 -->

        <h2>Flex Row</h2>

        <div class="bg-dark p-3 d-flex flex-row">
            <div class="h-25 p-3 bg-success">Flex Item A</div>
            <div class="h-25 p-3 bg-warning">Flex Item B</div>
            <div class="h-25 p-3 bg-danger">Flex Item C</div>
        </div>

        <h2>Flex Row reverse</h2>
        <div class="bg-dark p-3 d-flex flex-row flex-row-reverse">
            <div class="h-25 p-3 bg-success">Flex Item A</div>
            <div class="h-25 p-3 bg-warning">Flex Item B</div>
            <div class="h-25 p-3 bg-danger">Flex Item C</div>
        </div>

        <h2>Creating Space Between Elements</h2>
        <div class="bg-dark p-3 d-md-flex justify-content-around">
            <div class="p-3 bg-success col-md-2">Card A</div>
            <div class="p-3 bg-warning col-md-2">Card B</div>
            <div class="p-3 bg-danger col-md-2">Card C</div>

        </div>

        <!--
			Important Note:
				- The "mr-auto" class will occupy the remaining width of it's parent container pushing all other elements inline.
			-->

        <h2>Flexbox with Margin</h2>
        <div class="bg-dark p-3 d-flex">
            <div class="p-3 bg-success mr-auto">Flex Item A</div>
            <div class="p-3 bg-warning">Flex Item B</div>
            <div class="p-3 bg-danger">Flex Item C</div>
            <div class="p-3 bg-primary">Flex Item D</div>
        </div>

        <h2>Nested Flex Elements</h2>
        <div class="bg-dark p-3 d-block d-md-flex">
            <div class="p-3 bg-success mr-auto">Flex Item A</div>
            <div class="w-50 d-block d-md-flex justify-content-between">
                <div class="p-3 bg-warning">Flex Item B</div>
                <div class="p-3 bg-danger">Flex Item c</div>
                <div class="p-3 bg-primary">Flex Item D</div>
            </div>
        </div>

        <h2>Sample Images in Flex</h2>
        <div class="d-md-flex justify-content-around">
            <img src="https://i.pinimg.com/originals/dc/ab/b7/dcabb7fbb2f763d680d20a3d228cc6f9.jpg"
                class="p-3 img-fluid order-2" style="height: 200px; width: 200px;">
            <img src="https://encrypted-tbn0.gstatic.com/images?q=tbn:ANd9GcS13yH3S1cvJviPNZKUlwtX5teAGS4CVRqOXw&usqp=CAU"
                class="p-3 img-fluid order-1" style="height: 200px; width: 200px;">
            <img src="https://assets.pokemon.com/assets/cms2/img/pokedex/full/143.png" class="p-3 img-fluid order-3"
                style="height: 200px; width: 200px; ">
        </div>
    </div>




    <script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js"
        integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous">
    </script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js"
        integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct" crossorigin="anonymous">
    </script>
</body>

</html>